BEGIN
  BEGIN TRANSACTION;

  DECLARE @ErrorMessage NVARCHAR(MAX);
  DECLARE @ErrorSeverity INT;
  DECLARE @ErrorState INT;

  BEGIN TRY
    IF OBJECT_ID('dbo.TaxTemplateMaps_insert') IS NOT NULL
      DROP TRIGGER dbo.TaxTemplateMaps_insert;
    IF OBJECT_ID('dbo.EntityTypeAssignments_delete') IS NOT NULL
      DROP TRIGGER dbo.EntityTypeAssignments_delete;
    IF OBJECT_ID('dbo.TaxTemplateMaps_delete') IS NOT NULL
      DROP TRIGGER dbo.TaxTemplateMaps_delete;
    IF OBJECT_ID('dbo.EntityTypeAssignments_update') IS NOT NULL
      DROP TRIGGER dbo.EntityTypeAssignments_update;
    IF OBJECT_ID('dbo.TaxTemplateMaps_update') IS NOT NULL
      DROP TRIGGER dbo.TaxTemplateMaps_update;
    IF OBJECT_ID('dbo.EntityTypes_insert') IS NOT NULL
      DROP TRIGGER dbo.EntityTypes_insert;
    IF OBJECT_ID('dbo.TaxTemplates_insert') IS NOT NULL
      DROP TRIGGER dbo.TaxTemplates_insert;
    IF OBJECT_ID('dbo.EntityTypes_delete') IS NOT NULL
      DROP TRIGGER dbo.EntityTypes_delete;
    IF OBJECT_ID('dbo.TaxTemplates_delete') IS NOT NULL
      DROP TRIGGER dbo.TaxTemplates_delete;
    IF OBJECT_ID('dbo.EntityTypes_update') IS NOT NULL
      DROP TRIGGER dbo.EntityTypes_update;
    IF OBJECT_ID('dbo.TaxTemplates_update') IS NOT NULL
      DROP TRIGGER dbo.TaxTemplates_update;
    IF OBJECT_ID('dbo.ForeignCurrencies_insert') IS NOT NULL
      DROP TRIGGER dbo.ForeignCurrencies_insert;
    IF OBJECT_ID('dbo.Terminals_insert') IS NOT NULL
      DROP TRIGGER dbo.Terminals_insert;
    IF OBJECT_ID('dbo.ForeignCurrencies_delete') IS NOT NULL
      DROP TRIGGER dbo.ForeignCurrencies_delete;
    IF OBJECT_ID('dbo.Terminals_delete') IS NOT NULL
      DROP TRIGGER dbo.Terminals_delete;
    IF OBJECT_ID('dbo.ForeignCurrencies_update') IS NOT NULL
      DROP TRIGGER dbo.ForeignCurrencies_update;
    IF OBJECT_ID('dbo.Terminals_update') IS NOT NULL
      DROP TRIGGER dbo.Terminals_update;
    IF OBJECT_ID('dbo.InventoryItems_insert') IS NOT NULL
      DROP TRIGGER dbo.InventoryItems_insert;
    IF OBJECT_ID('dbo.TicketEntities_insert') IS NOT NULL
      DROP TRIGGER dbo.TicketEntities_insert;
    IF OBJECT_ID('dbo.InventoryItems_delete') IS NOT NULL
      DROP TRIGGER dbo.InventoryItems_delete;
    IF OBJECT_ID('dbo.TicketEntities_delete') IS NOT NULL
      DROP TRIGGER dbo.TicketEntities_delete;
    IF OBJECT_ID('dbo.InventoryItems_update') IS NOT NULL
      DROP TRIGGER dbo.InventoryItems_update;
    IF OBJECT_ID('dbo.TicketEntities_update') IS NOT NULL
      DROP TRIGGER dbo.TicketEntities_update;
    IF OBJECT_ID('dbo.InventoryItemUnits_insert') IS NOT NULL
      DROP TRIGGER dbo.InventoryItemUnits_insert;
    IF OBJECT_ID('dbo.Tickets_insert') IS NOT NULL
      DROP TRIGGER dbo.Tickets_insert;
    IF OBJECT_ID('dbo.InventoryItemUnits_delete') IS NOT NULL
      DROP TRIGGER dbo.InventoryItemUnits_delete;
    IF OBJECT_ID('dbo.Tickets_delete') IS NOT NULL
      DROP TRIGGER dbo.Tickets_delete;
    IF OBJECT_ID('dbo.InventoryItemUnits_update') IS NOT NULL
      DROP TRIGGER dbo.InventoryItemUnits_update;
    IF OBJECT_ID('dbo.Tickets_update') IS NOT NULL
      DROP TRIGGER dbo.Tickets_update;
    IF OBJECT_ID('dbo.InventoryTransactionDocuments_insert') IS NOT NULL
      DROP TRIGGER dbo.InventoryTransactionDocuments_insert;
    IF OBJECT_ID('dbo.TicketTagGroups_insert') IS NOT NULL
      DROP TRIGGER dbo.TicketTagGroups_insert;
    IF OBJECT_ID('dbo.InventoryTransactionDocuments_delete') IS NOT NULL
      DROP TRIGGER dbo.InventoryTransactionDocuments_delete;
    IF OBJECT_ID('dbo.TicketTagGroups_delete') IS NOT NULL
      DROP TRIGGER dbo.TicketTagGroups_delete;
    IF OBJECT_ID('dbo.InventoryTransactionDocuments_update') IS NOT NULL
      DROP TRIGGER dbo.InventoryTransactionDocuments_update;
    IF OBJECT_ID('dbo.TicketTagGroups_update') IS NOT NULL
      DROP TRIGGER dbo.TicketTagGroups_update;
    IF OBJECT_ID('dbo.InventoryTransactionDocumentTypes_insert') IS NOT NULL
      DROP TRIGGER dbo.InventoryTransactionDocumentTypes_insert;
    IF OBJECT_ID('dbo.TicketTagMaps_insert') IS NOT NULL
      DROP TRIGGER dbo.TicketTagMaps_insert;
    IF OBJECT_ID('dbo.InventoryTransactionDocumentTypes_delete') IS NOT NULL
      DROP TRIGGER dbo.InventoryTransactionDocumentTypes_delete;
    IF OBJECT_ID('dbo.TicketTagMaps_delete') IS NOT NULL
      DROP TRIGGER dbo.TicketTagMaps_delete;
    IF OBJECT_ID('dbo.InventoryTransactionDocumentTypes_update') IS NOT NULL
      DROP TRIGGER dbo.InventoryTransactionDocumentTypes_update;
    IF OBJECT_ID('dbo.TicketTagMaps_update') IS NOT NULL
      DROP TRIGGER dbo.TicketTagMaps_update;
    IF OBJECT_ID('dbo.InventoryTransactions_insert') IS NOT NULL
      DROP TRIGGER dbo.InventoryTransactions_insert;
    IF OBJECT_ID('dbo.TicketTags_insert') IS NOT NULL
      DROP TRIGGER dbo.TicketTags_insert;
    IF OBJECT_ID('dbo.InventoryTransactions_delete') IS NOT NULL
      DROP TRIGGER dbo.InventoryTransactions_delete;
    IF OBJECT_ID('dbo.TicketTags_delete') IS NOT NULL
      DROP TRIGGER dbo.TicketTags_delete;
    IF OBJECT_ID('dbo.InventoryTransactions_update') IS NOT NULL
      DROP TRIGGER dbo.InventoryTransactions_update;
    IF OBJECT_ID('dbo.TicketTags_update') IS NOT NULL
      DROP TRIGGER dbo.TicketTags_update;
    IF OBJECT_ID('dbo.InventoryTransactionTypes_insert') IS NOT NULL
      DROP TRIGGER dbo.InventoryTransactionTypes_insert;
    IF OBJECT_ID('dbo.TicketTypes_insert') IS NOT NULL
      DROP TRIGGER dbo.TicketTypes_insert;
    IF OBJECT_ID('dbo.InventoryTransactionTypes_delete') IS NOT NULL
      DROP TRIGGER dbo.InventoryTransactionTypes_delete;
    IF OBJECT_ID('dbo.TicketTypes_delete') IS NOT NULL
      DROP TRIGGER dbo.TicketTypes_delete;
    IF OBJECT_ID('dbo.InventoryTransactionTypes_update') IS NOT NULL
      DROP TRIGGER dbo.InventoryTransactionTypes_update;
    IF OBJECT_ID('dbo.TicketTypes_update') IS NOT NULL
      DROP TRIGGER dbo.TicketTypes_update;
    IF OBJECT_ID('dbo.MenuAssignments_insert') IS NOT NULL
      DROP TRIGGER dbo.MenuAssignments_insert;
    IF OBJECT_ID('dbo.UserRoles_insert') IS NOT NULL
      DROP TRIGGER dbo.UserRoles_insert;
    IF OBJECT_ID('dbo.MenuAssignments_delete') IS NOT NULL
      DROP TRIGGER dbo.MenuAssignments_delete;
    IF OBJECT_ID('dbo.UserRoles_delete') IS NOT NULL
      DROP TRIGGER dbo.UserRoles_delete;
    IF OBJECT_ID('dbo.MenuAssignments_update') IS NOT NULL
      DROP TRIGGER dbo.MenuAssignments_update;
    IF OBJECT_ID('dbo.Accounts_insert') IS NOT NULL
      DROP TRIGGER dbo.Accounts_insert;
    IF OBJECT_ID('dbo.UserRoles_update') IS NOT NULL
      DROP TRIGGER dbo.UserRoles_update;
    IF OBJECT_ID('dbo.MenuItemPortions_insert') IS NOT NULL
      DROP TRIGGER dbo.MenuItemPortions_insert;
    IF OBJECT_ID('dbo.Accounts_delete') IS NOT NULL
      DROP TRIGGER dbo.Accounts_delete;
    IF OBJECT_ID('dbo.Users_insert') IS NOT NULL
      DROP TRIGGER dbo.Users_insert;
    IF OBJECT_ID('dbo.MenuItemPortions_delete') IS NOT NULL
      DROP TRIGGER dbo.MenuItemPortions_delete;
    IF OBJECT_ID('dbo.Accounts_update') IS NOT NULL
      DROP TRIGGER dbo.Accounts_update;
    IF OBJECT_ID('dbo.Users_delete') IS NOT NULL
      DROP TRIGGER dbo.Users_delete;
    IF OBJECT_ID('dbo.MenuItemPortions_update') IS NOT NULL
      DROP TRIGGER dbo.MenuItemPortions_update;
    IF OBJECT_ID('dbo.AccountScreens_insert') IS NOT NULL
      DROP TRIGGER dbo.AccountScreens_insert;
    IF OBJECT_ID('dbo.Users_update') IS NOT NULL
      DROP TRIGGER dbo.Users_update;
    IF OBJECT_ID('dbo.MenuItemPriceDefinitions_insert') IS NOT NULL
      DROP TRIGGER dbo.MenuItemPriceDefinitions_insert;
    IF OBJECT_ID('dbo.AccountScreens_delete') IS NOT NULL
      DROP TRIGGER dbo.AccountScreens_delete;
    IF OBJECT_ID('dbo.WarehouseConsumptions_insert') IS NOT NULL
      DROP TRIGGER dbo.WarehouseConsumptions_insert;
    IF OBJECT_ID('dbo.MenuItemPriceDefinitions_delete') IS NOT NULL
      DROP TRIGGER dbo.MenuItemPriceDefinitions_delete;
    IF OBJECT_ID('dbo.AccountScreens_update') IS NOT NULL
      DROP TRIGGER dbo.AccountScreens_update;
    IF OBJECT_ID('dbo.WarehouseConsumptions_delete') IS NOT NULL
      DROP TRIGGER dbo.WarehouseConsumptions_delete;
    IF OBJECT_ID('dbo.MenuItemPriceDefinitions_update') IS NOT NULL
      DROP TRIGGER dbo.MenuItemPriceDefinitions_update;
    IF OBJECT_ID('dbo.AccountScreenValues_insert') IS NOT NULL
      DROP TRIGGER dbo.AccountScreenValues_insert;
    IF OBJECT_ID('dbo.WarehouseConsumptions_update') IS NOT NULL
      DROP TRIGGER dbo.WarehouseConsumptions_update;
    IF OBJECT_ID('dbo.MenuItemPrices_insert') IS NOT NULL
      DROP TRIGGER dbo.MenuItemPrices_insert;
    IF OBJECT_ID('dbo.AccountScreenValues_delete') IS NOT NULL
      DROP TRIGGER dbo.AccountScreenValues_delete;
    IF OBJECT_ID('dbo.Warehouses_insert') IS NOT NULL
      DROP TRIGGER dbo.Warehouses_insert;
    IF OBJECT_ID('dbo.MenuItemPrices_delete') IS NOT NULL
      DROP TRIGGER dbo.MenuItemPrices_delete;
    IF OBJECT_ID('dbo.AccountScreenValues_update') IS NOT NULL
      DROP TRIGGER dbo.AccountScreenValues_update;
    IF OBJECT_ID('dbo.Warehouses_delete') IS NOT NULL
      DROP TRIGGER dbo.Warehouses_delete;
    IF OBJECT_ID('dbo.MenuItemPrices_update') IS NOT NULL
      DROP TRIGGER dbo.MenuItemPrices_update;
    IF OBJECT_ID('dbo.AccountTransactionDocumentAccountMaps_insert') IS NOT NULL
      DROP TRIGGER dbo.AccountTransactionDocumentAccountMaps_insert;
    IF OBJECT_ID('dbo.Warehouses_update') IS NOT NULL
      DROP TRIGGER dbo.Warehouses_update;
    IF OBJECT_ID('dbo.MenuItems_insert') IS NOT NULL
      DROP TRIGGER dbo.MenuItems_insert;
    IF OBJECT_ID('dbo.AccountTransactionDocumentAccountMaps_delete') IS NOT NULL
      DROP TRIGGER dbo.AccountTransactionDocumentAccountMaps_delete;
    IF OBJECT_ID('dbo.WarehouseTypes_insert') IS NOT NULL
      DROP TRIGGER dbo.WarehouseTypes_insert;
    IF OBJECT_ID('dbo.MenuItems_delete') IS NOT NULL
      DROP TRIGGER dbo.MenuItems_delete;
    IF OBJECT_ID('dbo.AccountTransactionDocumentAccountMaps_update') IS NOT NULL
      DROP TRIGGER dbo.AccountTransactionDocumentAccountMaps_update;
    IF OBJECT_ID('dbo.WarehouseTypes_delete') IS NOT NULL
      DROP TRIGGER dbo.WarehouseTypes_delete;
    IF OBJECT_ID('dbo.MenuItems_update') IS NOT NULL
      DROP TRIGGER dbo.MenuItems_update;
    IF OBJECT_ID('dbo.AccountTransactionDocuments_insert') IS NOT NULL
      DROP TRIGGER dbo.AccountTransactionDocuments_insert;
    IF OBJECT_ID('dbo.WarehouseTypes_update') IS NOT NULL
      DROP TRIGGER dbo.WarehouseTypes_update;
    IF OBJECT_ID('dbo.Numerators_insert') IS NOT NULL
      DROP TRIGGER dbo.Numerators_insert;
    IF OBJECT_ID('dbo.AccountTransactionDocuments_delete') IS NOT NULL
      DROP TRIGGER dbo.AccountTransactionDocuments_delete;
    IF OBJECT_ID('dbo.Widgets_insert') IS NOT NULL
      DROP TRIGGER dbo.Widgets_insert;
    IF OBJECT_ID('dbo.Numerators_delete') IS NOT NULL
      DROP TRIGGER dbo.Numerators_delete;
    IF OBJECT_ID('dbo.AccountTransactionDocuments_update') IS NOT NULL
      DROP TRIGGER dbo.AccountTransactionDocuments_update;
    IF OBJECT_ID('dbo.Widgets_delete') IS NOT NULL
      DROP TRIGGER dbo.Widgets_delete;
    IF OBJECT_ID('dbo.Numerators_update') IS NOT NULL
      DROP TRIGGER dbo.Numerators_update;
    IF OBJECT_ID('dbo.AccountTransactionDocumentTypeMaps_insert') IS NOT NULL
      DROP TRIGGER dbo.AccountTransactionDocumentTypeMaps_insert;
    IF OBJECT_ID('dbo.Widgets_update') IS NOT NULL
      DROP TRIGGER dbo.Widgets_update;
    IF OBJECT_ID('dbo.Orders_insert') IS NOT NULL
      DROP TRIGGER dbo.Orders_insert;
    IF OBJECT_ID('dbo.AccountTransactionDocumentTypeMaps_delete') IS NOT NULL
      DROP TRIGGER dbo.AccountTransactionDocumentTypeMaps_delete;
    IF OBJECT_ID('dbo.WorkPeriods_insert') IS NOT NULL
      DROP TRIGGER dbo.WorkPeriods_insert;
    IF OBJECT_ID('dbo.Orders_delete') IS NOT NULL
      DROP TRIGGER dbo.Orders_delete;
    IF OBJECT_ID('dbo.AccountTransactionDocumentTypeMaps_update') IS NOT NULL
      DROP TRIGGER dbo.AccountTransactionDocumentTypeMaps_update;
    IF OBJECT_ID('dbo.WorkPeriods_delete') IS NOT NULL
      DROP TRIGGER dbo.WorkPeriods_delete;
    IF OBJECT_ID('dbo.Orders_update') IS NOT NULL
      DROP TRIGGER dbo.Orders_update;
    IF OBJECT_ID('dbo.AccountTransactionDocumentTypes_insert') IS NOT NULL
      DROP TRIGGER dbo.AccountTransactionDocumentTypes_insert;
    IF OBJECT_ID('dbo.WorkPeriods_update') IS NOT NULL
      DROP TRIGGER dbo.WorkPeriods_update;
    IF OBJECT_ID('dbo.OrderTagGroups_insert') IS NOT NULL
      DROP TRIGGER dbo.OrderTagGroups_insert;
    IF OBJECT_ID('dbo.AccountTransactionDocumentTypes_delete') IS NOT NULL
      DROP TRIGGER dbo.AccountTransactionDocumentTypes_delete;
    IF OBJECT_ID('dbo.VersionInfo_insert') IS NOT NULL
      DROP TRIGGER dbo.VersionInfo_insert;
    IF OBJECT_ID('dbo.OrderTagGroups_delete') IS NOT NULL
      DROP TRIGGER dbo.OrderTagGroups_delete;
    IF OBJECT_ID('dbo.AccountTransactionDocumentTypes_update') IS NOT NULL
      DROP TRIGGER dbo.AccountTransactionDocumentTypes_update;
    IF OBJECT_ID('dbo.VersionInfo_update') IS NOT NULL
      DROP TRIGGER dbo.VersionInfo_update;
    IF OBJECT_ID('dbo.OrderTagGroups_update') IS NOT NULL
      DROP TRIGGER dbo.OrderTagGroups_update;
    IF OBJECT_ID('dbo.AccountTransactions_insert') IS NOT NULL
      DROP TRIGGER dbo.AccountTransactions_insert;
    IF OBJECT_ID('dbo.AccountTransactionDocumentTypeAccountTransactionTypes_insert') IS NOT NULL
      DROP TRIGGER dbo.AccountTransactionDocumentTypeAccountTransactionTypes_insert;
    IF OBJECT_ID('dbo.OrderTagMaps_insert') IS NOT NULL
      DROP TRIGGER dbo.OrderTagMaps_insert;
    IF OBJECT_ID('dbo.AccountTransactions_delete') IS NOT NULL
      DROP TRIGGER dbo.AccountTransactions_delete;
    IF OBJECT_ID('dbo.AccountTransactionDocumentTypeAccountTransactionTypes_update') IS NOT NULL
      DROP TRIGGER dbo.AccountTransactionDocumentTypeAccountTransactionTypes_update;
    IF OBJECT_ID('dbo.OrderTagMaps_delete') IS NOT NULL
      DROP TRIGGER dbo.OrderTagMaps_delete;
    IF OBJECT_ID('dbo.AccountTransactions_update') IS NOT NULL
      DROP TRIGGER dbo.AccountTransactions_update;
    IF OBJECT_ID('dbo.CalculationSelectorCalculationTypes_insert') IS NOT NULL
      DROP TRIGGER dbo.CalculationSelectorCalculationTypes_insert;
    IF OBJECT_ID('dbo.OrderTagMaps_update') IS NOT NULL
      DROP TRIGGER dbo.OrderTagMaps_update;
    IF OBJECT_ID('dbo.AccountTransactionTypes_insert') IS NOT NULL
      DROP TRIGGER dbo.AccountTransactionTypes_insert;
    IF OBJECT_ID('dbo.CalculationSelectorCalculationTypes_update') IS NOT NULL
      DROP TRIGGER dbo.CalculationSelectorCalculationTypes_update;
    IF OBJECT_ID('dbo.OrderTags_insert') IS NOT NULL
      DROP TRIGGER dbo.OrderTags_insert;
    IF OBJECT_ID('dbo.AccountTransactionTypes_delete') IS NOT NULL
      DROP TRIGGER dbo.AccountTransactionTypes_delete;
    IF OBJECT_ID('dbo.OrderTags_delete') IS NOT NULL
      DROP TRIGGER dbo.OrderTags_delete;
    IF OBJECT_ID('dbo.AccountTransactionTypes_update') IS NOT NULL
      DROP TRIGGER dbo.AccountTransactionTypes_update;
    IF OBJECT_ID('dbo.OrderTags_update') IS NOT NULL
      DROP TRIGGER dbo.OrderTags_update;
    IF OBJECT_ID('dbo.AccountTransactionValues_insert') IS NOT NULL
      DROP TRIGGER dbo.AccountTransactionValues_insert;
    IF OBJECT_ID('dbo.PaidItems_insert') IS NOT NULL
      DROP TRIGGER dbo.PaidItems_insert;
    IF OBJECT_ID('dbo.AccountTransactionValues_delete') IS NOT NULL
      DROP TRIGGER dbo.AccountTransactionValues_delete;
    IF OBJECT_ID('dbo.PaidItems_delete') IS NOT NULL
      DROP TRIGGER dbo.PaidItems_delete;
    IF OBJECT_ID('dbo.AccountTransactionValues_update') IS NOT NULL
      DROP TRIGGER dbo.AccountTransactionValues_update;
    IF OBJECT_ID('dbo.PaidItems_update') IS NOT NULL
      DROP TRIGGER dbo.PaidItems_update;
    IF OBJECT_ID('dbo.AccountTypes_insert') IS NOT NULL
      DROP TRIGGER dbo.AccountTypes_insert;
    IF OBJECT_ID('dbo.Payments_insert') IS NOT NULL
      DROP TRIGGER dbo.Payments_insert;
    IF OBJECT_ID('dbo.AccountTypes_delete') IS NOT NULL
      DROP TRIGGER dbo.AccountTypes_delete;
    IF OBJECT_ID('dbo.Payments_delete') IS NOT NULL
      DROP TRIGGER dbo.Payments_delete;
    IF OBJECT_ID('dbo.AccountTypes_update') IS NOT NULL
      DROP TRIGGER dbo.AccountTypes_update;
    IF OBJECT_ID('dbo.Payments_update') IS NOT NULL
      DROP TRIGGER dbo.Payments_update;
    IF OBJECT_ID('dbo.ActionContainers_insert') IS NOT NULL
      DROP TRIGGER dbo.ActionContainers_insert;
    IF OBJECT_ID('dbo.PaymentTypeMaps_insert') IS NOT NULL
      DROP TRIGGER dbo.PaymentTypeMaps_insert;
    IF OBJECT_ID('dbo.ActionContainers_delete') IS NOT NULL
      DROP TRIGGER dbo.ActionContainers_delete;
    IF OBJECT_ID('dbo.PaymentTypeMaps_delete') IS NOT NULL
      DROP TRIGGER dbo.PaymentTypeMaps_delete;
    IF OBJECT_ID('dbo.ActionContainers_update') IS NOT NULL
      DROP TRIGGER dbo.ActionContainers_update;
    IF OBJECT_ID('dbo.PaymentTypeMaps_update') IS NOT NULL
      DROP TRIGGER dbo.PaymentTypeMaps_update;
    IF OBJECT_ID('dbo.AddonLicenses_insert') IS NOT NULL
      DROP TRIGGER dbo.AddonLicenses_insert;
    IF OBJECT_ID('dbo.PaymentTypes_insert') IS NOT NULL
      DROP TRIGGER dbo.PaymentTypes_insert;
    IF OBJECT_ID('dbo.AddonLicenses_delete') IS NOT NULL
      DROP TRIGGER dbo.AddonLicenses_delete;
    IF OBJECT_ID('dbo.PaymentTypes_delete') IS NOT NULL
      DROP TRIGGER dbo.PaymentTypes_delete;
    IF OBJECT_ID('dbo.AddonLicenses_update') IS NOT NULL
      DROP TRIGGER dbo.AddonLicenses_update;
    IF OBJECT_ID('dbo.PaymentTypes_update') IS NOT NULL
      DROP TRIGGER dbo.PaymentTypes_update;
    IF OBJECT_ID('dbo.AppActions_insert') IS NOT NULL
      DROP TRIGGER dbo.AppActions_insert;
    IF OBJECT_ID('dbo.PeriodicConsumptionItems_insert') IS NOT NULL
      DROP TRIGGER dbo.PeriodicConsumptionItems_insert;
    IF OBJECT_ID('dbo.AppActions_delete') IS NOT NULL
      DROP TRIGGER dbo.AppActions_delete;
    IF OBJECT_ID('dbo.PeriodicConsumptionItems_delete') IS NOT NULL
      DROP TRIGGER dbo.PeriodicConsumptionItems_delete;
    IF OBJECT_ID('dbo.AppActions_update') IS NOT NULL
      DROP TRIGGER dbo.AppActions_update;
    IF OBJECT_ID('dbo.PeriodicConsumptionItems_update') IS NOT NULL
      DROP TRIGGER dbo.PeriodicConsumptionItems_update;
    IF OBJECT_ID('dbo.AppRuleMaps_insert') IS NOT NULL
      DROP TRIGGER dbo.AppRuleMaps_insert;
    IF OBJECT_ID('dbo.PeriodicConsumptions_insert') IS NOT NULL
      DROP TRIGGER dbo.PeriodicConsumptions_insert;
    IF OBJECT_ID('dbo.AppRuleMaps_delete') IS NOT NULL
      DROP TRIGGER dbo.AppRuleMaps_delete;
    IF OBJECT_ID('dbo.PeriodicConsumptions_delete') IS NOT NULL
      DROP TRIGGER dbo.PeriodicConsumptions_delete;
    IF OBJECT_ID('dbo.AppRuleMaps_update') IS NOT NULL
      DROP TRIGGER dbo.AppRuleMaps_update;
    IF OBJECT_ID('dbo.PeriodicConsumptions_update') IS NOT NULL
      DROP TRIGGER dbo.PeriodicConsumptions_update;
    IF OBJECT_ID('dbo.AppRules_insert') IS NOT NULL
      DROP TRIGGER dbo.AppRules_insert;
    IF OBJECT_ID('dbo.Permissions_insert') IS NOT NULL
      DROP TRIGGER dbo.Permissions_insert;
    IF OBJECT_ID('dbo.AppRules_delete') IS NOT NULL
      DROP TRIGGER dbo.AppRules_delete;
    IF OBJECT_ID('dbo.Permissions_delete') IS NOT NULL
      DROP TRIGGER dbo.Permissions_delete;
    IF OBJECT_ID('dbo.AppRules_update') IS NOT NULL
      DROP TRIGGER dbo.AppRules_update;
    IF OBJECT_ID('dbo.Permissions_update') IS NOT NULL
      DROP TRIGGER dbo.Permissions_update;
    IF OBJECT_ID('dbo.AutomationCommandMaps_insert') IS NOT NULL
      DROP TRIGGER dbo.AutomationCommandMaps_insert;
    IF OBJECT_ID('dbo.PrinterMaps_insert') IS NOT NULL
      DROP TRIGGER dbo.PrinterMaps_insert;
    IF OBJECT_ID('dbo.AutomationCommandMaps_delete') IS NOT NULL
      DROP TRIGGER dbo.AutomationCommandMaps_delete;
    IF OBJECT_ID('dbo.PrinterMaps_delete') IS NOT NULL
      DROP TRIGGER dbo.PrinterMaps_delete;
    IF OBJECT_ID('dbo.AutomationCommandMaps_update') IS NOT NULL
      DROP TRIGGER dbo.AutomationCommandMaps_update;
    IF OBJECT_ID('dbo.PrinterMaps_update') IS NOT NULL
      DROP TRIGGER dbo.PrinterMaps_update;
    IF OBJECT_ID('dbo.AutomationCommands_insert') IS NOT NULL
      DROP TRIGGER dbo.AutomationCommands_insert;
    IF OBJECT_ID('dbo.Printers_insert') IS NOT NULL
      DROP TRIGGER dbo.Printers_insert;
    IF OBJECT_ID('dbo.AutomationCommands_delete') IS NOT NULL
      DROP TRIGGER dbo.AutomationCommands_delete;
    IF OBJECT_ID('dbo.Printers_delete') IS NOT NULL
      DROP TRIGGER dbo.Printers_delete;
    IF OBJECT_ID('dbo.AutomationCommands_update') IS NOT NULL
      DROP TRIGGER dbo.AutomationCommands_update;
    IF OBJECT_ID('dbo.Printers_update') IS NOT NULL
      DROP TRIGGER dbo.Printers_update;
    IF OBJECT_ID('dbo.Calculations_insert') IS NOT NULL
      DROP TRIGGER dbo.Calculations_insert;
    IF OBJECT_ID('dbo.PrintJobs_insert') IS NOT NULL
      DROP TRIGGER dbo.PrintJobs_insert;
    IF OBJECT_ID('dbo.Calculations_delete') IS NOT NULL
      DROP TRIGGER dbo.Calculations_delete;
    IF OBJECT_ID('dbo.PrintJobs_delete') IS NOT NULL
      DROP TRIGGER dbo.PrintJobs_delete;
    IF OBJECT_ID('dbo.Calculations_update') IS NOT NULL
      DROP TRIGGER dbo.Calculations_update;
    IF OBJECT_ID('dbo.PrintJobs_update') IS NOT NULL
      DROP TRIGGER dbo.PrintJobs_update;
    IF OBJECT_ID('dbo.CalculationSelectorMaps_insert') IS NOT NULL
      DROP TRIGGER dbo.CalculationSelectorMaps_insert;
    IF OBJECT_ID('dbo.ProductTimerMaps_insert') IS NOT NULL
      DROP TRIGGER dbo.ProductTimerMaps_insert;
    IF OBJECT_ID('dbo.CalculationSelectorMaps_delete') IS NOT NULL
      DROP TRIGGER dbo.CalculationSelectorMaps_delete;
    IF OBJECT_ID('dbo.ProductTimerMaps_delete') IS NOT NULL
      DROP TRIGGER dbo.ProductTimerMaps_delete;
    IF OBJECT_ID('dbo.CalculationSelectorMaps_update') IS NOT NULL
      DROP TRIGGER dbo.CalculationSelectorMaps_update;
    IF OBJECT_ID('dbo.ProductTimerMaps_update') IS NOT NULL
      DROP TRIGGER dbo.ProductTimerMaps_update;
    IF OBJECT_ID('dbo.CalculationSelectors_insert') IS NOT NULL
      DROP TRIGGER dbo.CalculationSelectors_insert;
    IF OBJECT_ID('dbo.ProductTimers_insert') IS NOT NULL
      DROP TRIGGER dbo.ProductTimers_insert;
    IF OBJECT_ID('dbo.CalculationSelectors_delete') IS NOT NULL
      DROP TRIGGER dbo.CalculationSelectors_delete;
    IF OBJECT_ID('dbo.ProductTimers_delete') IS NOT NULL
      DROP TRIGGER dbo.ProductTimers_delete;
    IF OBJECT_ID('dbo.CalculationSelectors_update') IS NOT NULL
      DROP TRIGGER dbo.CalculationSelectors_update;
    IF OBJECT_ID('dbo.ProductTimers_update') IS NOT NULL
      DROP TRIGGER dbo.ProductTimers_update;
    IF OBJECT_ID('dbo.CalculationTypes_insert') IS NOT NULL
      DROP TRIGGER dbo.CalculationTypes_insert;
    IF OBJECT_ID('dbo.ProductTimerValues_insert') IS NOT NULL
      DROP TRIGGER dbo.ProductTimerValues_insert;
    IF OBJECT_ID('dbo.CalculationTypes_delete') IS NOT NULL
      DROP TRIGGER dbo.CalculationTypes_delete;
    IF OBJECT_ID('dbo.ProductTimerValues_delete') IS NOT NULL
      DROP TRIGGER dbo.ProductTimerValues_delete;
    IF OBJECT_ID('dbo.CalculationTypes_update') IS NOT NULL
      DROP TRIGGER dbo.CalculationTypes_update;
    IF OBJECT_ID('dbo.ProductTimerValues_update') IS NOT NULL
      DROP TRIGGER dbo.ProductTimerValues_update;
    IF OBJECT_ID('dbo.ChangePayments_insert') IS NOT NULL
      DROP TRIGGER dbo.ChangePayments_insert;
    IF OBJECT_ID('dbo.ProgramSettingValues_insert') IS NOT NULL
      DROP TRIGGER dbo.ProgramSettingValues_insert;
    IF OBJECT_ID('dbo.ChangePayments_delete') IS NOT NULL
      DROP TRIGGER dbo.ChangePayments_delete;
    IF OBJECT_ID('dbo.ProgramSettingValues_delete') IS NOT NULL
      DROP TRIGGER dbo.ProgramSettingValues_delete;
    IF OBJECT_ID('dbo.ChangePayments_update') IS NOT NULL
      DROP TRIGGER dbo.ChangePayments_update;
    IF OBJECT_ID('dbo.ProgramSettingValues_update') IS NOT NULL
      DROP TRIGGER dbo.ProgramSettingValues_update;
    IF OBJECT_ID('dbo.ChangePaymentTypeMaps_insert') IS NOT NULL
      DROP TRIGGER dbo.ChangePaymentTypeMaps_insert;
    IF OBJECT_ID('dbo.RecipeItems_insert') IS NOT NULL
      DROP TRIGGER dbo.RecipeItems_insert;
    IF OBJECT_ID('dbo.ChangePaymentTypeMaps_delete') IS NOT NULL
      DROP TRIGGER dbo.ChangePaymentTypeMaps_delete;
    IF OBJECT_ID('dbo.RecipeItems_delete') IS NOT NULL
      DROP TRIGGER dbo.RecipeItems_delete;
    IF OBJECT_ID('dbo.ChangePaymentTypeMaps_update') IS NOT NULL
      DROP TRIGGER dbo.ChangePaymentTypeMaps_update;
    IF OBJECT_ID('dbo.RecipeItems_update') IS NOT NULL
      DROP TRIGGER dbo.RecipeItems_update;
    IF OBJECT_ID('dbo.ChangePaymentTypes_insert') IS NOT NULL
      DROP TRIGGER dbo.ChangePaymentTypes_insert;
    IF OBJECT_ID('dbo.Recipes_insert') IS NOT NULL
      DROP TRIGGER dbo.Recipes_insert;
    IF OBJECT_ID('dbo.ChangePaymentTypes_delete') IS NOT NULL
      DROP TRIGGER dbo.ChangePaymentTypes_delete;
    IF OBJECT_ID('dbo.Recipes_delete') IS NOT NULL
      DROP TRIGGER dbo.Recipes_delete;
    IF OBJECT_ID('dbo.ChangePaymentTypes_update') IS NOT NULL
      DROP TRIGGER dbo.ChangePaymentTypes_update;
    IF OBJECT_ID('dbo.Recipes_update') IS NOT NULL
      DROP TRIGGER dbo.Recipes_update;
    IF OBJECT_ID('dbo.CostItems_insert') IS NOT NULL
      DROP TRIGGER dbo.CostItems_insert;
    IF OBJECT_ID('dbo.RefreshTokens_insert') IS NOT NULL
      DROP TRIGGER dbo.RefreshTokens_insert;
    IF OBJECT_ID('dbo.CostItems_delete') IS NOT NULL
      DROP TRIGGER dbo.CostItems_delete;
    IF OBJECT_ID('dbo.RefreshTokens_delete') IS NOT NULL
      DROP TRIGGER dbo.RefreshTokens_delete;
    IF OBJECT_ID('dbo.CostItems_update') IS NOT NULL
      DROP TRIGGER dbo.CostItems_update;
    IF OBJECT_ID('dbo.RefreshTokens_update') IS NOT NULL
      DROP TRIGGER dbo.RefreshTokens_update;
    IF OBJECT_ID('dbo.DataExports_insert') IS NOT NULL
      DROP TRIGGER dbo.DataExports_insert;
    IF OBJECT_ID('dbo.ScreenMenuCategories_insert') IS NOT NULL
      DROP TRIGGER dbo.ScreenMenuCategories_insert;
    IF OBJECT_ID('dbo.DataExports_delete') IS NOT NULL
      DROP TRIGGER dbo.DataExports_delete;
    IF OBJECT_ID('dbo.ScreenMenuCategories_delete') IS NOT NULL
      DROP TRIGGER dbo.ScreenMenuCategories_delete;
    IF OBJECT_ID('dbo.DataExports_update') IS NOT NULL
      DROP TRIGGER dbo.DataExports_update;
    IF OBJECT_ID('dbo.ScreenMenuCategories_update') IS NOT NULL
      DROP TRIGGER dbo.ScreenMenuCategories_update;
    IF OBJECT_ID('dbo.Departments_insert') IS NOT NULL
      DROP TRIGGER dbo.Departments_insert;
    IF OBJECT_ID('dbo.ScreenMenuItems_insert') IS NOT NULL
      DROP TRIGGER dbo.ScreenMenuItems_insert;
    IF OBJECT_ID('dbo.Departments_delete') IS NOT NULL
      DROP TRIGGER dbo.Departments_delete;
    IF OBJECT_ID('dbo.ScreenMenuItems_delete') IS NOT NULL
      DROP TRIGGER dbo.ScreenMenuItems_delete;
    IF OBJECT_ID('dbo.Departments_update') IS NOT NULL
      DROP TRIGGER dbo.Departments_update;
    IF OBJECT_ID('dbo.ScreenMenuItems_update') IS NOT NULL
      DROP TRIGGER dbo.ScreenMenuItems_update;
    IF OBJECT_ID('dbo.Entities_insert') IS NOT NULL
      DROP TRIGGER dbo.Entities_insert;
    IF OBJECT_ID('dbo.ScreenMenus_insert') IS NOT NULL
      DROP TRIGGER dbo.ScreenMenus_insert;
    IF OBJECT_ID('dbo.Entities_delete') IS NOT NULL
      DROP TRIGGER dbo.Entities_delete;
    IF OBJECT_ID('dbo.ScreenMenus_delete') IS NOT NULL
      DROP TRIGGER dbo.ScreenMenus_delete;
    IF OBJECT_ID('dbo.Entities_update') IS NOT NULL
      DROP TRIGGER dbo.Entities_update;
    IF OBJECT_ID('dbo.ScreenMenus_update') IS NOT NULL
      DROP TRIGGER dbo.ScreenMenus_update;
    IF OBJECT_ID('dbo.EntityCustomFields_insert') IS NOT NULL
      DROP TRIGGER dbo.EntityCustomFields_insert;
    IF OBJECT_ID('dbo.Scripts_insert') IS NOT NULL
      DROP TRIGGER dbo.Scripts_insert;
    IF OBJECT_ID('dbo.EntityCustomFields_delete') IS NOT NULL
      DROP TRIGGER dbo.EntityCustomFields_delete;
    IF OBJECT_ID('dbo.Scripts_delete') IS NOT NULL
      DROP TRIGGER dbo.Scripts_delete;
    IF OBJECT_ID('dbo.EntityCustomFields_update') IS NOT NULL
      DROP TRIGGER dbo.EntityCustomFields_update;
    IF OBJECT_ID('dbo.Scripts_update') IS NOT NULL
      DROP TRIGGER dbo.Scripts_update;
    IF OBJECT_ID('dbo.EntityScreenItems_insert') IS NOT NULL
      DROP TRIGGER dbo.EntityScreenItems_insert;
    IF OBJECT_ID('dbo.States_insert') IS NOT NULL
      DROP TRIGGER dbo.States_insert;
    IF OBJECT_ID('dbo.EntityScreenItems_delete') IS NOT NULL
      DROP TRIGGER dbo.EntityScreenItems_delete;
    IF OBJECT_ID('dbo.States_delete') IS NOT NULL
      DROP TRIGGER dbo.States_delete;
    IF OBJECT_ID('dbo.EntityScreenItems_update') IS NOT NULL
      DROP TRIGGER dbo.EntityScreenItems_update;
    IF OBJECT_ID('dbo.States_update') IS NOT NULL
      DROP TRIGGER dbo.States_update;
    IF OBJECT_ID('dbo.EntityScreenMaps_insert') IS NOT NULL
      DROP TRIGGER dbo.EntityScreenMaps_insert;
    IF OBJECT_ID('dbo.TaskCustomFields_insert') IS NOT NULL
      DROP TRIGGER dbo.TaskCustomFields_insert;
    IF OBJECT_ID('dbo.EntityScreenMaps_delete') IS NOT NULL
      DROP TRIGGER dbo.EntityScreenMaps_delete;
    IF OBJECT_ID('dbo.TaskCustomFields_delete') IS NOT NULL
      DROP TRIGGER dbo.TaskCustomFields_delete;
    IF OBJECT_ID('dbo.EntityScreenMaps_update') IS NOT NULL
      DROP TRIGGER dbo.EntityScreenMaps_update;
    IF OBJECT_ID('dbo.TaskCustomFields_update') IS NOT NULL
      DROP TRIGGER dbo.TaskCustomFields_update;
    IF OBJECT_ID('dbo.EntityScreens_insert') IS NOT NULL
      DROP TRIGGER dbo.EntityScreens_insert;
    IF OBJECT_ID('dbo.Tasks_insert') IS NOT NULL
      DROP TRIGGER dbo.Tasks_insert;
    IF OBJECT_ID('dbo.EntityScreens_delete') IS NOT NULL
      DROP TRIGGER dbo.EntityScreens_delete;
    IF OBJECT_ID('dbo.Tasks_delete') IS NOT NULL
      DROP TRIGGER dbo.Tasks_delete;
    IF OBJECT_ID('dbo.EntityScreens_update') IS NOT NULL
      DROP TRIGGER dbo.EntityScreens_update;
    IF OBJECT_ID('dbo.Tasks_update') IS NOT NULL
      DROP TRIGGER dbo.Tasks_update;
    IF OBJECT_ID('dbo.EntityStateLogs_insert') IS NOT NULL
      DROP TRIGGER dbo.EntityStateLogs_insert;
    IF OBJECT_ID('dbo.TaskTokens_insert') IS NOT NULL
      DROP TRIGGER dbo.TaskTokens_insert;
    IF OBJECT_ID('dbo.EntityStateLogs_delete') IS NOT NULL
      DROP TRIGGER dbo.EntityStateLogs_delete;
    IF OBJECT_ID('dbo.TaskTokens_delete') IS NOT NULL
      DROP TRIGGER dbo.TaskTokens_delete;
    IF OBJECT_ID('dbo.EntityStateLogs_update') IS NOT NULL
      DROP TRIGGER dbo.EntityStateLogs_update;
    IF OBJECT_ID('dbo.TaskTokens_update') IS NOT NULL
      DROP TRIGGER dbo.TaskTokens_update;
    IF OBJECT_ID('dbo.EntityStateValues_insert') IS NOT NULL
      DROP TRIGGER dbo.EntityStateValues_insert;
    IF OBJECT_ID('dbo.TaskTypes_insert') IS NOT NULL
      DROP TRIGGER dbo.TaskTypes_insert;
    IF OBJECT_ID('dbo.EntityStateValues_delete') IS NOT NULL
      DROP TRIGGER dbo.EntityStateValues_delete;
    IF OBJECT_ID('dbo.TaskTypes_delete') IS NOT NULL
      DROP TRIGGER dbo.TaskTypes_delete;
    IF OBJECT_ID('dbo.EntityStateValues_update') IS NOT NULL
      DROP TRIGGER dbo.EntityStateValues_update;
    IF OBJECT_ID('dbo.TaskTypes_update') IS NOT NULL
      DROP TRIGGER dbo.TaskTypes_update;
    IF OBJECT_ID('dbo.EntityTypeAssignments_insert') IS NOT NULL
      DROP TRIGGER dbo.EntityTypeAssignments_insert;

    DROP TABLE dbo.ReportTemp;

    CREATE TABLE dbo.ReportTemp
    (
      id INT IDENTITY(1, 1) NOT NULL,
      is_old INT NULL,
      table_name NVARCHAR(50) NULL,
      table_code NVARCHAR(50) NULL,
      items XML NULL,
      appkey NVARCHAR(50) NULL,
      type NVARCHAR(50) NULL,
      timestamp NVARCHAR(50) NULL
    ) ON [PRIMARY] TEXTIMAGE_ON [PRIMARY];

    COMMIT TRANSACTION;
  END TRY
  BEGIN CATCH
    IF @@TRANCOUNT > 0
      BEGIN
        ROLLBACK TRANSACTION;

        SET @ErrorMessage = ERROR_MESSAGE();
        SET @ErrorSeverity = ERROR_SEVERITY();
        SET @ErrorState = ERROR_STATE();
        RAISERROR(@ErrorMessage, @ErrorSeverity, @ErrorState);
      END;
  END CATCH;
END;
GO
